;================================================================================
// PDM samples at 15720Hz, 8 bits
;================================================================================
PlaySamplePDM_target_start = $600
;================================================================================

// if we need it faster, the main code of this could live in page 0..

	.proc PlaySamplePDM, PlaySamplePDM_target_start
	pha				; save return bank

Init
	lda #%11100000
	sta GRAFP0
	
.if .def PAL_VERSION
	lda #$FE
.else
	lda #$1E
.endif
	sta COLPM0

	
	lda #%1100100		// 1.79Mhz for channel 1 and 3, HiPass 1+3
	sta AUDCTL

	lda #$AF
    sta AUDC1
	lda #$10
    sta AUDC2
	
	lda #$A0
    sta AUDC3
	lda #$10
    sta AUDC4
	
	lda #0
    sta AUDF2
    sta AUDF4

    ; Set up 1/16 dutycycle HiPass on 1+3
	ldy #12
    sty AUDF1
	lda #13
    sta AUDF3
    sta STIMER
    sty AUDF3
	
	
	lda #32
	sta m_bankPages

FirstBankSMAddress
	ldx #SAMPLE1_FIRST_BANK		// first bank for the sample, that needs to be in consecutive banks
	sta $d500,x
	
	sta WSYNC
	sta WSYNC
	
PlayLoop
	ldy SampleCartBuffer
	lda TabAudioHighRam,y
	sta WSYNC
	sta AUDC2
	lda TabAudioLowRam,y
	sta AUDC1
	
	sty HPOSP0
	
    inc PlayLoop+1
    bne PlayLoop
    inc PlayLoop+2
	
    dec m_bankPages
    bne PlayLoop
	
	lda #32
	sta m_bankPages
	
    lda #>SampleCartBuffer		// reset pointer for next bank
    sta PlayLoop+2
	
	inx
	sta $d500,x

LastBankSMAddress
	cpx #[SAMPLE1_FIRST_BANK + SAMPLE1_CART_BANKS]
	bne PlayLoop

ExitPlayLoop
	lda #0
	sta AUDC1
	sta AUDC3
	
	lda #0
	sta GRAFP0

	pla
	tax
	sta $d500,x		; enable return bank
	
	rts
	.endp
	
PlaySamplePDM_size = .len PlaySamplePDM
PlaySamplePDM_cart_start = .adr PlaySamplePDM

