;================================================================================
// PDM samples at 15720Hz, 8 bits
;================================================================================
PlayTracksPDM_target_start = $400
;================================================================================

	.proc PlayTracksPDM, PlayTracksPDM_target_start
	pha				; save return bank

Init
	lda #%11100000
	sta GRAFP0
	
.if .def PAL_VERSION
	lda #$FE
.else
	lda #$1E
.endif
	sta COLPM0
	
	
	lda #%1100100		// 1.79Mhz for channel 1 and 3, HiPass 1+3
	sta AUDCTL

	lda #$AF
    sta AUDC1
	lda #$10
    sta AUDC2
	
	lda #$A0
    sta AUDC3
	lda #$10
    sta AUDC4
	
	lda #0
    sta AUDF2
    sta AUDF4

    ; Set up 1/16 dutycycle HiPass on 1+3
	ldy #12
    sty AUDF1
	lda #13
    sta AUDF3
    sta STIMER
    sty AUDF3
	
	
	sta WSYNC
	sta WSYNC

	jmp PlayTrack1_target_start		// for now always the first track


ExitPlayLoop
	lda #0
	sta AUDC1
	sta AUDC3
	
	lda #0
	sta GRAFP0
	
	pla
	tax
	sta $d500,x		; enable return bank
	
	rts
	
	.endp
	
PlayTracksPDM_size = .len PlayTracksPDM
PlayTracksPDM_cart_start = .adr PlayTracksPDM

;================================================================================
PlayTrack1_target_start = $500
;================================================================================

	.proc PlayTrack1, PlayTrack1_target_start
	
	lda #<SampleCartBuffer		// we can customize this init to start at any position in the bank (useful to pack all tracks)
    sta PlayLoopTrack+1
	lda #>SampleCartBuffer
    sta PlayLoopTrack+2

	ldx #SAMPLE1_FIRST_BANK		// first bank for the sample, that needs to be in consecutive banks

UpdateBankTrack
	sta $d500,x
	
PlayLoopTrack
	ldy SampleCartBuffer
	lda TabAudioHighRam,y
	sta WSYNC
	sta AUDC2
	lda TabAudioLowRam,y
	sta AUDC1
	
	tya
	lsr
	adc #64		// don't care about the carry..
	sta HPOSP0
	
    inc PlayLoopTrack+1
    bne CheckEndTrack
	
    inc PlayLoopTrack+2
	lda PlayLoopTrack+2
	cmp #$C0			// cart window end?
	beq CartEnd

CheckKeyEnd
	// lda SKSTAT
	// and #4			// any key pressed
	// bne PlayLoopTrack
	// jmp PlayTracksPDM.ExitPlayLoop
	
	lda CONSOL			// check START key pressed
	and #%001
	bne PlayLoopTrack
	jmp PlayTracksPDM.ExitPlayLoop

CartEnd
    lda #>SampleCartBuffer		// reset pointer for next bank
    sta PlayLoopTrack+2
	
	inx
	bne UpdateBankTrack			// "inx" is never going to be 0, so this is a forced jump

// for now NO track ends near a page boundary, so we don't check the end of a track in those cases!
CheckEndTrack
	cpx #[SAMPLE1_FIRST_BANK + SAMPLE1_CART_BANKS - 1]
	bne PlayLoopTrack
	
	lda PlayLoopTrack+1
	cmp #<[SampleCartBuffer+SAMPLE1_END_BANK_SIZE]
	bne PlayLoopTrack
	lda PlayLoopTrack+2
	cmp #>[SampleCartBuffer+SAMPLE1_END_BANK_SIZE]
	bne PlayLoopTrack

	//jmp PlayTrack1_target_start		// loop forever
	
	jmp PlayTracksPDM.ExitPlayLoop

	.endp
	
PlayTrack1_size = .len PlayTrack1
PlayTrack1_cart_start = .adr PlayTrack1

